#ifndef XINEMA_H_
#define XINEMA_H_

#include <msp/core/application.h>
#include <msp/core/mutex.h>
#include <msp/fs/path.h>
#include <msp/graphics/display.h>
#include <msp/graphics/window.h>
#include "networkinterface.h"

class XineEngine;
class XineStream;

class Xinema: public Msp::RegisteredApplication<Xinema>
{
private:
	Msp::Graphics::Display display;
	Msp::Mutex display_mutex;
	Msp::Graphics::Window window;
	NetworkInterface network;
	XineEngine *engine;
	XineStream *stream;

	Msp::Mutex command_mutex;
	std::string pending_mrl;

public:
	Xinema(int, char **);

	virtual int main();
private:
	virtual void tick();

public:
	void play_file(const Msp::FS::Path &);
};

#endif
